#include <dos.h>
#include <stdio.h>

void odczytajPozycjeKursora( unsigned char,
			     unsigned char *,
			     unsigned char * );
void ustawKursor( unsigned char,
		  unsigned char,
		  unsigned char );
void napiszZnak( unsigned char,
		 unsigned char,
		 unsigned char,
		 unsigned int );

void main( void )
{
int nrZnaku;
unsigned char wiersz,
	      kolumna;

printf( "\n\n  Wywietlenie zestawu znakw" );
printf( "\n-------------------------------" );

for ( nrZnaku = 0;
      nrZnaku != 256;
      nrZnaku++ )
{
   if ( (nrZnaku % 16) == 0 )
   {
      printf( "\n%.3u-%.3u  ", nrZnaku, nrZnaku+15 );
      odczytajPozycjeKursora( 0, &wiersz, &kolumna );
      }

   napiszZnak( 0, (unsigned char)nrZnaku, 7, 1 );
   ++kolumna;
   ustawKursor( 0, wiersz, kolumna );
   }
}

void odczytajPozycjeKursora( unsigned char strona,
			     unsigned char *wiersz,
			     unsigned char *kolumna )
{
union REGS regs;

regs.h.ah = 3;
regs.h.bh = strona;
int86( 0x10, &regs, &regs );
*wiersz = regs.h.dh;
*kolumna = regs.h.dl;
}

void ustawKursor( unsigned char strona,
		  unsigned char wiersz,
		  unsigned char kolumna )
{
union REGS regs;

regs.h.ah = 2;
regs.h.bh = strona;
regs.h.dh = wiersz;
regs.h.dl = kolumna;
int86( 0x10, &regs, &regs );
}

void napiszZnak( unsigned char strona,
		 unsigned char znak,
		 unsigned char atrybut,
		 unsigned int ile )
{
union REGS regs;

regs.h.ah = 9;
regs.h.al = znak;
regs.h.bh = strona;
regs.h.bl = atrybut;
regs.x.cx = ile;
int86( 0x10, &regs, &regs );
}
